//Calcul_4eme_ordre - Scilab function - 
//Return the zeros and the pole of a fourth order digital PLL type 2
//Based on a NSC's Model
//13 juillet 2004 - IRCOM GROUP - Author : A.Layec
function [tau1,tau,tau2]=calcul_4eme_ordre(fn,phi,kv,icp,N,fcpf,attn)
    wn=2*%pi*fn;
    tau2=(-tan(phi)+1/cos(phi))/wn;
    tau3=sqrt((10^(attn/10)-1)/(2*%pi*fcpf)^2);
    wc=((tan(phi)*(tau2+tau3)/((tau2+tau3)^2+tau2*tau3)))*(sqrt(1+(((tau2+tau3)^2+tau2*tau3))/(tan(phi)*(tau2+tau3)^2))-1);
    tau1=1/((wc^2)*(tau2+tau3));
    c1=(tau2/tau1)*(kv*(icp/(2*%pi))/((wc^2)*N))*sqrt((1+wc^2*tau1^2)/((1+(wc^2)*(tau2^2))*(1+(wc^2)*(tau3^2))));
    c2=c1*(tau1/tau2-1);
    r2=tau1/c2;
    c3=c1/10;
    r3=tau3/c3;
endfunction

