/* cmplxa_c subroutine
 * complex addition computation
 * IRCOM GROUP - Author : A.Layec
 *
 * Copyright (C) 2007 Alan Layec
 *
 * This file is part of modnumlib.
 *
 * modnumlib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * modnumlib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with modnumlib; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "modnum_lib.h"

/* cmplxa_c routine de calcul d'addition-soustraction de vecteurs complexes
 *
 * n           : la taille des vecteurs
 * sig         : signe de l'opration
 * [z1_r;z1_i] : adresses de dpart du vecteur complexe 1
 * [z2_r;z2_i] : adresses de dpart du vecteur complexe 2
 * [y_r;y_i]   : adresses de dpart du vecteur complexe rsultat
 *
 * rmq : doit exister en version BLAS(!?)
 */

void cmplxa_c(int *n,int *sig,double *z1_r,double *z1_i,double *z2_r,double *z2_i,double *y_r,double *y_i)
{
 /*dclaration des variables*/
 int i;

 /*ralise multiplication complex*/
 for(i=0;i<(*n);i++)
 {
  y_r[i]=z1_r[i]+(*sig)*z2_r[i];
  y_i[i]=z1_i[i]+(*sig)*z2_i[i];
 }

 return;
}
