/* genint_c subroutine
 * Random Integer Number Generator
 * IRCOM GROUP - Author : A.Layec
 *
 * Copyright (C) 2007 Alan Layec
 *
 * This file is part of modnumlib.
 *
 * modnumlib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * modnumlib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with modnumlib; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

/* REVISION HISTORY :
 * $Log$
 */

#include <stdlib.h>

#include "modnum_lib.h"

/* genint_c routine de calcul de mots entiers alatoires
 * Entres :
 * n   : taille du  vecteur de sortie (scalaire)
 * m   : longueur des mots binaires des lments du vecteur de sorties (scalaire)
 * typ : type des gnrateurs binaires (scalaire)
 * (typ=0: gnre 1 seul bit cod NRZ
 *    =1: gnre 1 seul bit cod RZ, ou un mot non sign
 *    =2: gnre un mot cod code complment  2)
 * Sorties :
 * y : vecteur de sortie
 *
 * dpendances
 * math.h
 */

void genint_c(int *n,int *m,int *typ,double *y)
{
 /*dclaration des variables compteurs*/
 int k,i,j;

 for(i=0;i<(*n);i++)
 {
  switch (*typ)
  {
   /*Type 0 -> ddi signal NRZ*/
   case 0:
   {
    y[i]=(int)((rand()&1)*2-1);
    break;
   }
   /*Type 1 -> mot non sign*/
   case 1 :
   {
    k=1;
    k=k<<(*m);
    j=rand();
    y[i]=(j&(k-1));
    break;
   }
   /*Type 2 -> mot cod code complmnt  2*/
   case 2 :
   {
    j=rand();
    j -= 2<<((*m)-2);
    j &= (2<<((*m)-1)) - 1;
    j -= 2<<((*m)-2);
    y[i]=j;
    break;
   }
   break;
  }
 }
 return;
}
