/* mod_num_lib.h header for mod_num_lib
 * INRIA - Author : A.Layec
 *
 * Copyright (C) 2007 Alan Layec
 *
 * This file is part of modnumlib.
 *
 * modnumlib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * modnumlib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with modnumlib; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

/* REVISION HISTORY :
 * $Log$
 */

#define M_PI		3.14159265358979323846

#define Abs(x) ( (x) > 0) ? (x) : -(x)

extern void modpsk_c(int *n,int *m,double *u,double *i_c, double *q_c);
extern void demodpsk_c(int *n,int *m,double *i_c,double *i_q,double*y);
extern void modqam_c(int *n,int *m,double *u,double *i_c,double *q_c);
extern void demodqam_c(int *n,int *m,double *i_c,double *q_c,double *y);
extern void modgen_c(int *n,int *m,double *u,double *u_r,double *u_i, \
                     double *i_c, double *q_c);
extern void demodgen_c(int *n,int *m,double *i_c, double *q_c, \
                       double *u_r,double *u_i,double *y);

extern void genint_c(int *n,int *m,int *typ,double *y);

extern void surecht_c(int *opt,int *n,int *nech,int *init_c,double *u,double *y);
extern void sousecht_c(int *n,int *nech,int *init_c,double *u,double*y);

extern void cmplxm_c(int *n,double *z1_r,double *z1_i, \
                     double *z2_r,double *z2_i,double *y_r,double *y_i);
extern void cmplxa_c(int *n,int *sig,double *z1_r,double *z1_i, \
                     double *z2_r,double *z2_i,double *y_r,double *y_i);

extern void codinser_c(int *nuc,int *nus,double *c,double *s,double *y);
extern void decod_c(int *nuc,int *nus,double *c,double *s,double *y);

extern void overlapadr_c(int *m1,int *n,int *nb_coef,double *u_r,double *z_r);
extern void overlaprsr_c(int *n,int *m,double *u,double *y,double *z);

extern void convolfft_c(int *m1,double *z1_r,double *z1_i,double *z2_r,double *z2_i, \
                        double *y_r,double *y_i);
extern void convolr_c(int *n,int *nb_coef,int *m1,double *z1_r,double *z1_i, \
                      double *z2_r,double *z2_i,double *y_r,double *y_i,double *z_r);
extern void intsym_c(int *n,int *nech,int *init_c,double *step,double *u, \
                     double *y,double *z);
extern void comp_c(int *n,double *ampl,double *u,double *y);
extern void nfilter_c(int *n,int *nbcoef,double *u,double *pulse,double *y,double *z);

extern void bin_c(int *n,int *m,int *typ,double *y);
extern void cw_c(int *n,double *ampl,int *opt,double *theta_i, \
                 double *y1,double *y2,double *theta);
extern void noiseiq_c(int *n,double *sig,double *mean,double *i_c,double *i_q);
extern void noiseblk_c(int *n,int *typ,double *sig,double *mean,double *y);
extern void gold_c(int *N, int *ny,double *y,int *reg1, int *reg2,int *coef1, int *coef2);
extern void mllsrs_c(int *N, int *ny,double *y,int *reg, int *coef);

extern void cpf_c(int *n,int *nev,double *z1,double *z2,double *y1,double *y2);
extern void cpft_c(int *n,int *nev,int *flag,double *delay,double *z1,double *z2, \
                   double *evout,double *y1,double *y2,double *sh);
extern void chargepump_c(int *n,double *up,double *down,double *Io, int *typ_leak, \
                         double *Ileak_m,double *Ileak_d,double *Icp);

extern void dsm1_c(int *n,double *m,double *u,double *e,double *z, \
                    double *y,double *q);
extern void dsm2_c(int *n,double *m,double *u,double *e,double *z, \
                    double *y,double *q,double *w);
extern void dsm3_c(int *n,double *m,double *u,double *e,double *z, \
                    double *y,double *q,double *w);

extern void adc_c(int *n,int *type,int *nbit, int *cc2,int *qn,double *q,double *vmin, \
                  double *of_er, double *fsr_er,double *u,double *y1,double *y2);
extern void dac_c(int *n,int *nbit, int *cc2,double *q,double *vmin, \
                  double *u,double *y);

extern void calc_win_c(int *n,int *wtyp,double *param,double *y);
extern void filter_tap_c(int *n,int *typ,int *ne,double *param,double *y);
