/* sousecht Scicos temporal undersamplig
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 22 Dcembre 2004 Author : - IRCOM GROUP - A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "modnum_lib.h"
#include "scicos_block.h"

/* Cette fonction de simulation ralise un sous chantillonnage d'un
 * vecteur d'entre de taille nu vers un vecteur de sortie de taille ny.
 * Pour chaque vecteur, la fonction recopie les valeurs de u dans y
 * lorsque l'chantillon test est celui qui correspond au numro count
 * exemple count = c.i + nech
 *
 * Entre rgulire : signal surechantilonn
 * Sortie rgulire : signal sous chantillonns
 * Entre vnementielle : nant
 * Sortie vnementielle : nant
 *
 * Paramtres entier :     insz[0] : taille du vecteur en entre
 *                         ipar[0] : nombre d'chantillons
 *
 * tat discret      :     z[0] : valeur initiale du numro chantillons
 */

/*prototype*/
void sousecht(scicos_block *block,int flag)
{
 /*Dclaration des variables*/
 double *y;
 double *u;
 int nu,nech,counter;

 /*Rcupration des adresses des ports rguliers*/
 y=(double *)block->outptr[0];
 u=(double *)block->inptr[0];

 /*Rcupration du nombre d'chantillons*/
 nu=block->insz[0];
 nech=block->ipar[0];

 /*Le flag1*/
 if(flag==1)
 {
  counter=(int)block->z[0];
  /*Appel routine sousecht_c*/
  sousecht_c(&nu,&nech,&counter,&u[0],&y[0]);
 }
}
