/* surecht Scicos temporal oversamplig and zero insert block
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 21 dcembre 2004 Author : - IRCOM GROUP - A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "modnum_lib.h"
#include "scicos_block.h"

/* Entre rgulire : signal  surechantilonner
 * Sortie rgulire : signal surchantilonn
 * Entre vnementielle : nant
 * Sortie vnementielle : nant
 *
 * Paramtres entier : insz[0] : taille du vecteur en entre
 *                    ipar[0] : nombre d'chantillons
 *                    ipar[1] : option
 *                              0/1 : traitement squentiel
 *                              2/3 : traitement vectoriel
 *                              0/2 : pas d'insertion de zro
 *                              1/3 : insertion zro
 *
 * tat discret     : z[0] : valeur initiale du numro chantillons
 */

/*prototype*/
void surecht(scicos_block *block,int flag)
{
  /*dclaration des variables*/
  double *y;
  double *u;
  int i,opt,nu,nech,ny;
  int counter;

  /*Rcupration des adresses des ports rguliers*/
  y=(double *)block->outptr[0];
  u=(double *)block->inptr[0];

  /*rcupration du nombre d'chantillons*/
  nu=block->insz[0];
  nech=block->ipar[0];
  ny=block->outsz[0];
  opt=block->ipar[1];

  /* Le flag 1 teste la valeur du compteur chantillon
   * et dlivre u[] dans y[] quand le compteur
   * arrive  la valeur ipar[0]
   */
  if(flag==1)
    {/*Vector*/
     if (opt==2||opt==3)
     {
      opt=opt-2;
      counter=(int)block->z[0];
      /*Appel routine surecht_c*/
      surecht_c(&opt,&nu,&nech,&counter,&u[0],&y[0]);
     }
     /*scalar*/
     else if(opt==0)
     {
      /*si z[]=ipar[0] y[]=u[]*/
      if((int)block->z[0]==nech)
      {
       block->z[0]=1; /*RAZ compteur*/
       for(i=0;i<block->insz[0];i++) y[i]=u[i];
      }
      /*si z[]!=ipar[0] y[]=0*/
      else
      {
       for(i=0;i<block->insz[0];i++) y[i]=0;
       block->z[0]++; /*incrmente compteur*/
      }
     }
     else if(opt==1)
     {
      for(i=0;i<block->insz[0];i++) y[i]=u[i];
     }
    }
}
