/* z_buft41 Scicos discrete event memory block
 * Type 4 simulation function ver 1.0 - scilab-4.1
 * 31 Mars 2007 - INRIA - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */
#include "scicos_block.h"
#include "machine.h"

/* Cette fonction de simulation est un buffer qui mmorise
 * les dates de dclenchement dans le vecteur des tats discrets z
 * si le paramtre entier ipar[1] est plac  1 alors la
 * fonction calcul les carts temporels entre chaques activation
 *
 * entre rgulire : nant
 * sortie rgulire : nant
 * entre vnementielle : Date de dclenchement
 * sortie vnementielle : nant
 *
 * tat discret : z[0] : compteur chantillon
 *                z[1] : date d'activation prcdente
 *                z[2..2+n-1] : mot mmoire
 *
 * paramtre entier : ipar[0] : longueur du mot mmoire (n)
 *                    ipar[1]  : option : 1 : calcul du jitter period
 */

/*prototype*/
void z_buft41(scicos_block *block,int flag)
{
 /*dclaration des variables*/
 int j,n;
 double t;

 /*le flag 2 mmorise t dans z[]*/
 if(flag==2)
 {
  /*rcupration de la longeur du mot mmoire*/
  n=block->ipar[0];
  /*rcupre valeur du compteur chantillons*/
  j=(int)block->z[0];
  /*rcupre la date d'activation*/
  t=get_scicos_time();
  /*met en mmoire dans z ou calcule la priode jitter*/
  if (block->ipar[1]==1) {
    block->z[2+j]=t-block->z[1];
  }
  else {
    block->z[2+j]=t;
  }
  /*met en mmoire la date d'activation*/
  block->z[1]=t;
  /*incrmente compteur chantillons*/
  j++;
  /*Test valeur compteur chantillons*/
  if(j==n) j=0;
  /*mmorise compteur dans z[n+1]*/
  block->z[0]=(double)j;
 }
}
