/* ndelay Scicos vector delay block
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 18 novembre 2003 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "machine.h"

/* Cette fonction de simulation prsente la valeur du vecteur u[]
 * sur le vecteur de sortie y[] aprs n priode de dclenchements.
 * Elle se compose d'un vecteur de registre  dcalage dont chaque registre
 * a une taille donne par le paramtre entier ipar[0..Nu-1] o Nu reprsente
 * la taille des vecteurs d'entres/sorties.
 *
 * entre rgulire u[0..Nu-1] : vecteur d'entre
 * sortie rgulier y[0..Nu-1] : vecteur de sortie
 * entre vnementielle : priode de dclenchement
 * sortie vnementielle : nant
 *
 * paramtre entier ipar[0..Nu-1] :  vecteur des nombres de retard
 * tats discrets : z[0..ipar[0]-1] : buffer entre u[0]
 *                  z[ipar[0]..ipar[1]-1] : buffer entre u[1]
 *                 ...........
 *                 z[ipar[Nu-2]..ipar[Nu-1] : buffer entre u[Nu-1]
 */

/*prototype*/
void ndelay(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
            ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
 /*Dclaration*/
 double *y;
 double *u;
 int nu,i,j,n;

 /*rcupration des adresses des ports rguliers*/
 y = (double *)outptr[0];
 u = (double *)inptr[0];

 /*rcupration de la taille du port d'entre*/
 nu=insz[0];

 switch (*flag)
 {
  /* Le flag 1 place la premire valeur du buffer
   * dans le registre de sortie y[]
   */
  case 1 :
  {
   n = 0;
   for (i=0;i<nu;i++)
   {
    y[i]=z[n];
    n=n+ipar[i];
   }
   break;
  }

  /* Le flag 2 fait un dcalage  gauche des buffers
   * et place la valeur de u[]  la sortie des buffers
   */
  case 2 :
  {
   /*Dcale buffer*/
   n = 0;
   for (i=0;i<nu;i++)
   {
    for (j=0;j<ipar[i];j++) z[n+j]=z[n+j+1];
    n=n+ipar[i];
   }
   /*Ajoute nouvelle valeur dans buffer*/
   n = 0;
   for(j=0;j<nu;j++)
   {
    n=n+ipar[j];
    z[n-1]=u[j];
   }
   break;
  }
  break;
 }
}
