/* nintegr Scicos vector intgerator
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 16 novembre 2003 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "machine.h"

/* Cette fonction de simulation ralise l'intgration simple
 * du vecteur u[] par le solveur ODE intgr et place le rsultat dans y[]
 *
 * entre rgulires : u[0..nu-1] vecteur d'entre
 * sorties rgulires : y[0..nu-1] registre de sortie
 * entre vnementielle : nant (temps dpendant)
 * sortie vnementielle : nant.
 * tat continu : u[0..in_size-1] vecteur des tats continus
 */

/*Prototype*/
void nintegr(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
             ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
 /*Dclaration*/
 double *y;
 double *u;
 int i,nu;

 /*Rcupration des addresses des ports rguliers*/
 y = (double *)outptr[0];
 u = (double *)inptr[0];

 /*Rcupration de la taille du port d'entre rgulier*/
 nu=insz[0];

 /*Le flag 1 place le vecteur des tats continus x[]*/
 /*dans le registre de sortie y[]*/
 if(*flag == 1)
    for(i=0;i<nu;i++) y[i]=x[i];

 /*Le flag 2 place les valeurs d'entre u[]*/
 /*dans le vecteur des drives xd[]*/
 else if(*flag ==0)
    for(i=0;i<nu;i++) xd[i]=u[i];
}
