//Define simulation name
sim_name='synthe_int_jit_sim';
//Define simulation path
sim_path='synthe_int_jit_sim';
//Load scicos diagram
load(MODNUM+'/simu/'+sim_path+'/'+sim_name+'.cos');
//Tests for scicos version
ierr = execstr('current_version=get_scicos_version()','errcatch')
if ierr==0 then //scilab > 4.1x
 //check version
 if type(scs_m)==17 then
    if find(getfield(1,scs_m)=='version')<>[] then
       if scs_m.version<>'' then
         scicos_ver=scs_m.version
       end
    end
 end
 if current_version<>scicos_ver then
    scs_m=do_version(scs_m,scicos_ver)
 end
end
//Define context
exec(MODNUM+'/simu/'+sim_path+'/'+sim_name+'_ctxt.sce');
context=scs_m.props("context");execstr(context);
//Define Simulation end time
scs_m.props.tf=Tfin;
//Define other variables

j=1;
//substitue context variable to be sweep
//scs_m.props.context=subst_ctxt('varname','varname=');
//Initialise Info and %scicos_context variable
clear Info;Info=list();
clear %scicos_context;
%scicos_context=struct();
//Do simulation with scicos_simulate
Info=scicos_simulate(scs_m,Info,%scicos_context);
//Load result
myvar=return_state_block(Info,"z_buft");

f=scf(10);
plot2d(1:Nsav,myvar(1)(1:Nsav)-1/Fd,rect=[0 min(myvar(1)(1:Nsav)-1/Fd) Nsav max(myvar(1)(1:Nsav)-1/Fd)]);
xtitle('Period jitter for '+scs_m.props.context(3)+';'+scs_m.props.context(12));
g=scf(20);
histplot(100,myvar(1)(1:Nsav)-1/Fd);
xtitle('Probility density of period jitter for '+scs_m.props.context(3)+';'+scs_m.props.context(12));